#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 1A.0 - Premiers pas en Python (correction)

# La partie 1 ne nécessite pas de correction.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Partie 2

# Les erreurs sont corrigées de telle sorte que la ligne fautive est mise en commentaires ou que le commentaire indique la correction.
# 
# **Un oubli**

# In[2]:


a = 5
a = a + 4  # a + 4
print (a)


# Si on affecte pas le résultat d'une opération à une variable, il est perdu.
# 
# **Une erreur de syntaxe**

# In[3]:


a = 0
for i in range (0, 10) :  # il manquait : en fin de ligne
    a = a + i
print (a)


# **Une autre erreur de syntaxe**

# In[4]:


a = 0
for i in range (0, 10):
    a = a + i
    print (a)      # il manquait deux espaces


# L'indentation est stricte en Python : elle indique la séparation entre des blocs d'instructions. Si les lignes ne sont pas bien alignées, l'interpréteur ne sait plus à quel bloc associer la ligne.
# 
# **Une opération interdite**

# In[5]:


a = 0
s = "e"
# print (a + s)  # pas de correction


# Il n'existe pas de correction dans ce cas, il s'agit d'une opération interdite. De la même manière l'opération suivante est interdite aussi car on ajoute des informations de type différent :

# In[6]:


1 + "1"     # déclenche une exception


# Pour faire le calcule, il faut convertir les deux variables dans le même type :

# In[7]:


print(1 + int("1"))
print(str(1) + "1")


# Le premier résultat est un entier. Le second est une chaîne de caractères. Les deux chaînes "1" + "1" ont été collées ensemble.
# 
# **Un nombre impair de...**

# In[8]:


a = 0
for i in range (0, 10) :
      a = (a + (i+2)*3)  # il manquait une parenthèse à la fin
print (a)   


# ### Partie 3

# **Ecrire un programme qui calcule la somme des 10 premiers entiers au carré**

# In[9]:


s = 0
for i in range(1,11):   # range énumère les entiers de 1 à 11 exclu
    s += i
print(s)


# Une autre version en écriture abrégée :

# In[10]:


r = sum ( i for i in range(1,11) )
print(r)


# **Ecrire un programme qui calcule la somme des 5 premiers entiers impairs au carré**

# In[11]:


s = 0
for i in range(1,11):
    if i % 2 == 1 :
        print("ajoute",i)
        s += i
print("résultat",s)


# De la même manière, en écriture abrégée :

# In[12]:


r = sum ( i for i in range(1,11) if i%2 == 1 )
print(r)


# **Ecrire un programme qui calcule la somme des qui 10 premmières factorielles : $\sum_{i=1}^{10} i!$**

# In[13]:


s = 0
f = 1
for i in range(1,11):
    f *= i
    s += f
print("résultat",s)


# Il faut introduire une variable intermédiaire car le résultat qu'on cherche à calculer est la somme d'un produit. A chaque itération, on utilise le résultat de la somme à l'itération précédente ainsi que la valeur de la factorielle. La notation abrégée est plus difficile à écrire.